# Checamos que no existe jaque con dos
# damas en el mismo rengln
sub checa_renglon( \@ )
{
	my $p = shift;

	for( my $i=0; $i<=6; $i++ ) {
		my $valor = $p->[$i];
		for( my $j=$i+1; $j<=7; $j++ ) {
			if( $p->[$j] == $valor ) {
				return 1;
			}
		}
	}
	return 0;
}

# Jaque con damas en diagonal
sub checa_diagonal( \@ )
{
	my $p = shift;

	for( my $i=0; $i<=6; $i++ ) {
		for( my $j=$i+1; $j<=7; $j++ ) {
			my $valor = $j - $i;
			if( abs($p->[$i] - $p->[$j]) == $valor ) {
				return 1;
			}
		}
	}
	return 0;
}


sub imprime_tablero( \@ )
{
	my $p = shift;

	for( my $i=0; $i<=7; $i++ ) {
		for( my $j=0; $j<=7; $j++ ) {
			$valor = $p->[$j];
			if( $valor == $i ) {
				print "* ";
			}
			else {
				print "- ";
			}
		}
		print "\n";
	}
	print "\n";
}

$solucion = 1;
for( $i=0; $i<=7; $i++ ) {
	$posicion[0] = $i;
	for( $j=0; $j<=7; $j++ ) {
		$posicion[1] = $j;
		for( $k=0; $k<=7; $k++ ) {
			$posicion[2] = $k;
			for( $l=0; $l<=7; $l++ ) {
				$posicion[3] = $l;
				for( $m=0; $m<=7; $m++ ) {
					$posicion[4] = $m;
					for( $n=0; $n<=7; $n++ ) {
						$posicion[5] = $n;
						for( $o=0; $o<=7; $o++ ) {
							$posicion[6] = $o;
							for( $p=0; $p<=7; $p++ ) {
								$posicion[7] = $p;
								$v1 = checa_renglon( @posicion);
								if( $v1 == 0 ) {
									$v2 = checa_diagonal(@posicion);
									if( $v2 == 0 ) {
										print "Solucin $solucion\n";
										imprime_tablero(@posicion);
										$solucion++;
									}
								}
							}
						}
					}
				}
			}
		}
	}
}
